enyo.kind({
    name: "maklesoft.browser.ActionBar",
	kind: enyo.VFlexBox,
	defaultKind: "ToolButton",
	pack: "center",
	className: "enyo-toolbar actionbar",
	published: {
		url: "",
		title: "",
		canGoBack: false,
		canGoForward: false,
		canShare: true,
		searchPreferences: {},
		defaultSearch: "",
		progress: 0,
		loading: false
	},
    events: {
		onBack: "",
		onForward: "",
		onLoad: "",
		onStopLoad: "",
		onRefresh: "",
		onAddBookmark: "",
		onAddToLauncher: "",
		onShareLink: "",
		onOpenBookmarks: "",
		onNewCard: "",
        onSearch: "",
        onNewTab: "",
        onOpenStartPage: "",
        onDeleteBookmark: "",
        onAddToInstaPaper: "",
        onTweetUrl: "",
        onShowTabs: "",
        onHideTabs: ""
    },
    create: function() {
		this.inherited(arguments);
		this.urlChanged();
		this.titleChanged();
		this.canGoBackChanged();
		this.canGoForwardChanged();
		this.canShareChanged();
		this.loadingChanged();
        this.applyStyle("z-index", "100");
        this.searchIndex = 0;
    },
	//* @public
	resize: function() {
		this.$.search.resize();
	},
	forceFocus: function() {
		this.$.search.forceFocus();
	},
	forceBlur: function() {
		this.$.search.closeSearchPopup();
	},
	urlChanged: function() {
		this.$.search.setUrl(this.url);
	},
	titleChanged: function() {
		this.$.title.setContent(this.title || $L("Untitled"));
	},
	canGoBackChanged: function() {
		this.$.back.setDisabled(!this.canGoBack);
	},
	canGoForwardChanged: function() {
		this.$.forward.setDisabled(!this.canGoForward);
	},
	canShareChanged: function() {
		this.$.share.setDisabled(!this.canShare);
	},
	searchPreferencesChanged: function() {
		this.$.search.setSearchPreferences(this.searchPreferences);
	},
	defaultSearchChanged: function() {
		this.$.search.setDefaultSearch(this.defaultSearch);
	},
	showSharePopup: function(inSender, inEvent) {
		this.$.sharePopup.openAt({top: -1000});
		var pop = this.$.sharePopup.getBounds(); 
		this.$.sharePopup.close();
		this.$.sharePopup.openAtControl(this.$.share, {left: -pop.width+10, top: 26});
	},
	progressChanged: function() {
		this.$.progressBar.setPosition(this.progress);
	},
	loadingChanged: function() {
		this.$.search.setLoading(this.loading);
		if (this.loading) {
			if (this.$.progressBar.hasClass("invisible")) {
				this.$.progressBar.removeClass("invisible");
			}
		} else {
			if (!this.$.progressBar.hasClass("invisible")) {
				this.$.progressBar.addClass("invisible"); 
			}
		}
	},
    toggleSearch: function() {
        if (this.$.toggleSearchButton.getDepressed()) {
            this.$.searchBar.open();
        } else {
            this.$.searchBar.close();
        }
        this.$.searchInput.forceFocus();
    },
    startSearch: function() {
        this.searchIndex = 0;
        this.search();
    },
    searchUp: function() {
        if (this.searchString == this.$.searchInput.getValue()) {
            this.searchIndex++;
        } else {
            this.searchIndex = 0;
        }
        this.search();
    },
    searchDown: function() {
        if (this.searchString == this.$.searchInput.getValue()) {
            this.searchIndex--;
        } else {
            this.searchIndex = 0;
        }
        this.search();
    },
    searchInputKeyPress: function(sender, event) {
        if (event.keyCode == 13) {
            this.startSearch();
        }
    },
    search: function() {
        this.searchString = this.$.searchInput.getValue();
        this.doSearch({text: this.searchString, index: this.searchIndex});
    },
    addBookmarkWithEdit: function() {
        this.doAddBookmark(true);
    },
	components: [
    	{kind: "Control", showing: false, name: "title", className: "page-title enyo-text-ellipsis", content: "Untitled"},
		{kind: enyo.HFlexBox, align: "center", className: "menu-container", components: [
			//{kind: "IconButton", name: "back", className: "nav-button back-button", icon: "images/chrome/menu-icon-back.png", onclick: "doBack"},
			//{kind: "IconButton", name: "forward", className: "nav-button forward-button", icon: "images/chrome/menu-icon-forward.png", onclick: "doForward"},
			{kind: "IconButton", name: "back", className: "nav-button back-button enyo-button-dark", icon: "images/chrome/menu-icon-back.png", onclick: "doBack", onmousehold: "doShowTabs"},
			{kind: "IconButton", name: "forward", className: "nav-button forward-button enyo-button-dark", icon: "images/chrome/menu-icon-forward.png", onclick: "doForward"},
			{kind: "ToolButton", name: "search", className: "actionbar-tool-button", flex: 1, kind: "URLSearch", onLoad: "doLoad", onStopLoad: "doStopLoad", onRefresh: "doRefresh", onAddBookmark: "doAddBookmark"},
			{kind: "ToolButton", name: "share", className: "actionbar-tool-button", icon: "images/chrome/menu-icon-share.png", onclick: "showSharePopup"},
			//{kind: "ToolButton", className: "actionbar-tool-button", icon: "images/chrome/menu-icon-newcard.png", onclick: "doNewCard"},
			//{kind: "ToolButton", className: "actionbar-tool-button", icon: "images/chrome/menu-icon-bookmark.png", onclick: "doOpenBookmarks"},
			{kind: "ToolButton", className: "actionbar-tool-button", icon: "images/chrome/menu-icon-home.png", onclick: "doOpenStartPage"},
			{kind: "ToolButton", className: "actionbar-tool-button", icon: "images/chrome/menu-icon-search.png", onclick: "toggleSearch", toggling: true, name: "toggleSearchButton"}
		]},	
		{name: "sharePopup", className: "launch-popup",  kind: "Menu", components: [
			{caption: $L("Add Bookmark"), onclick: "addBookmarkWithEdit"},
			{caption: $L("Share Link"), onclick: "doShareLink"},
			{caption: $L("Add to Launcher"), onclick: "doAddToLauncher"},
			{caption: $L("Send to Paper Mache (Instapaper)"), onclick: "doAddToInstaPaper"},
			{caption: $L("Share on Twitter (via Spaz)"), onclick: "doTweetUrl"}
		]},
		{name: "progressBar", kind: "ProgressBar", className: "url-progress invisible", animatePosition: false},
		{kind: "Toaster", layoutKind: "HFlexLayout", align: "center", dismissWithClick: false, name: "searchBar", flyInFrom: "right", className: "search-input", components: [
            {name: "searchInput", kind: "RoundedSearchInput", onchange: "startSearch",
                autoCapitalize: "lowercase", onkeypress: "searchInputKeyPress"},
			{kind: "ToolButton", style: "-webkit-transform: rotate(-90deg); padding: 0px; margin-right: -7px;", icon: "images/chrome/menu-icon-back.png", onclick: "searchUp"},
			{kind: "ToolButton", style: "-webkit-transform: rotate(90deg); padding: 0px; margin-left: -7px;", icon: "images/chrome/menu-icon-back.png", onclick: "searchDown"},
        ]}
	]
});