enyo.kind({
    name: "maklesoft.browser.AddressInput",
    kind: "AddressInput",
    events: {
        onAddBookmark: "",
        onDeleteBookmark: ""
    },
    create: function() {
        this.inherited(arguments);
        this.$.inputBox.createComponent(
			{name: "favButton", kind: "CustomButton", toggling: true, className: "addressbar-button fav-button", onclick: "addDeleteBookmark", owner: this}
        );
        this.createComponent({
            name: "bookmarksService", kind: "DbService", dbKind: enyo.fetchAppInfo().id + ".browserbookmarks:1", reCallWatches: true, method: "find",
            onSuccess: "gotBookmarks", subscribe: true, onWatch:"gotBookmarks"
        });
        this.checkBookmarks();
    },
    checkBookmarks: function() {
        this.$.bookmarksService.call({query: {where: [{prop: "url", op: "=", val: this.$.userinput.getValue()}]}});
    },
    gotBookmarks: function(sender, response) {
        if (response.results && response.results.length) {
            this.$.favButton.setDepressed(true);
            this.bookmark = true;
        } else {
            this.$.favButton.setDepressed(false);
            this.bookmark = false;
        }
    },
    addDeleteBookmark: function() {
        if (!this.bookmark) {
            enyo.log("adding bookmark...");
            this.doAddBookmark();
        } else {
            enyo.log("deleting bookmark...");
            this.deleteBookmark(this.bookmark);
        }
    },
    deleteCallback: function(sender, response) {
        //enyo.log("*** delete callback: " + JSON.stringify(response));
    },
	deleteBookmark: function(inSender, inBookmark) {
		this.$.bookmarksService.call({
		    query: {
		        from: this.$.bookmarksService.dbKind,
		        where: [{prop: "url", op: "=", val: this.$.userinput.getValue()}]
		    }
		}, {method: "del", onSuccess: "deleteCallback", onFailure: "deleteCallback"});
	},
	go: function() {
	    this.inherited(arguments);
	    this.checkBookmarks();
	},
	urlChanged: function() {
	    this.inherited(arguments);
	    this.checkBookmarks();
	}
});