enyo.kind({
    name: "AppInfo",
    kind: "Control",
    components: [
        {kind: "HFlexBox", style: "padding: 10px", align: "center", components: [
            {kind: "Image", name: "headerIcon", style: "width: 64px; height: 64px; margin-right: 10px"},
            {kind: "VFlexBox", align: "center", components: [
                {name: "title", style: "font-size: 24pt;"},
                {name: "version", style: "font-size: 12pt; color: Grey"}
            ]}
        ]},
        {kind: "Button", onclick: "openEmail", layoutKind: "HFlexLayout", pack: "center", caption: $L("Contact Support")},
        {kind: "Button", onclick: "doOpenVendorSite", layoutKind: "HFlexLayout", pack: "center", caption: $L("Visit Website")},
        {kind: "Button", onclick: "doOpenTwitter", layoutKind: "HFlexLayout", pack: "center", caption: $L("Follow Us")},
        {kind: "Button", onclick: "openAppCatalog", disabled: false, layoutKind: "HFlexLayout", pack: "center", caption: $L("Rate Me!")},
        {kind: "Button", onclick: "openMoreApps", layoutKind: "HFlexLayout", pack: "center", caption: $L("More Apps")},
        {kind: "Button", onclick: "doClose", className: "enyo-button-dark", layoutKind: "HFlexLayout", pack: "center", caption: $L("Close")},
        {name: "launchApp", kind: "PalmService", service: "palm://com.palm.applicationManager/", method: "open"},
        {kind: "Popup", name: "moreAppsPopup", components: [{kind: "MoreApps", onClose: "closeMoreApps"}]}
    ],
    events: {
        onClose: "",
        onOpenVendorSite: "",
        onOpenTwitter: ""
    },
    create: function() {
        this.inherited(arguments);
        this.appInfo = enyo.fetchAppInfo();

        this.$.headerIcon.setSrc("icon-256x256.png");
        this.$.title.setContent(this.appInfo.title);

        this.$.version.setContent("v" + this.appInfo.version + " by " + this.appInfo.vendor);
    },
    openWebsite: function() {
        this.$.launchApp.call({id: "com.palm.app.browser", params: {target: this.appInfo.support.url}});
    },
    openTwitter: function() {
        this.$.launchApp.call({id: "com.palm.app.browser", params: {target: "http://www.twitter.com/maklesoft"}});
    },
    openEmail: function() {
        this.$.launchApp.call({
            id: "com.palm.app.email",
            params: {
                summary: this.appInfo.title + " support request",
				text: "",
				recipients: [{
					contactDisplay: "MaKleSoft support",
					role: 1,
					value: this.appInfo.support.email
				}]
			}
		});
    },
    openAppCatalog: function() {
        this.$.launchApp.call({id: 'com.palm.app.enyo-findapps', params: {target: "http://developer.palm.com/appredirect/?packageid=" + this.appInfo.id}});
    },
    openMoreApps: function() {
        this.$.moreAppsPopup.openAtCenter();
    },
    closeMoreApps: function() {
        this.$.moreAppsPopup.close();
    }
});