enyo.kind({
    name: "AutoInsertTool",
    kind: "Toaster",
    //style: "display: none;",
    lazy: false,
    dismissWithClick: false,
    className: "auto-insert-box",
    published: {
        username: "",
        password: "",
        title: "auto insert",
        value: "",
        disabled: true
    },
    titleChanged: function() {
        this.$.title.setContent(this.title);
    },
    usernameChanged: function() {
        this.$.usernameButton.setValue(this.username);
        this.valueChanged();
    },
    passwordChanged: function() {
        this.$.passwordButton.setValue(this.password);
        this.valueChanged();
    },
    valueChanged: function() {
        this.$.radioGroup.setValue(this.value);
    },
    disabledChanged: function() {
        this.$.usernameButton.setDisabled(this.disabled);
        this.$.passwordButton.setDisabled(this.disabled);
    },
    create: function() {
        this.inherited(arguments);
        this.$.usernameButton.setValue(this.username);
        this.$.passwordButton.setValue(this.password);
        this.$.title.setContent(this.title);
        this.setValue(this.username);
        this.disabledChanged();
    },
    radioButtonChanged: function() {
        this.setValue(this.$.radioGroup.getValue());
    },
    open: function() {
        this.inherited(arguments);
        this.setDisabled(false);
        //this.applyStyle("display", "block");
        enyo.keyboard.setManualMode(true);
    },
    close: function() {
        this.inherited(arguments);
        this.setDisabled(true);
        //this.applyStyle("display", "none");
        enyo.keyboard.setManualMode(false);
    },
    components: [{
        kind: "HFlexBox", align: "center", components: [{
            name: "title", flex: 1, className: "auto-insert-title ellipsis"
        },
//        { kind: "ToolButton", name: "helpButton",
//            className: "help-button",
//            icon: "images/help_button_32.png",
//            onclick: "showHelp" },
		{kind: "CustomButton", className: "bookmark-grid-button stop-button", onclick: "close"}]
    },{
        className: "auto-insert-hint", content: $L("Tap on an input field to auto fill your data!")
    },{
        kind: "RadioGroup", onChange: "radioButtonChanged",
        components: [{
            label: "username", name: "usernameButton"
        },{
            label: "password", name: "passwordButton"
        }]
    }]
});

enyo.kind({
    name: "AutoInsertTest",
    kind: "VFlexBox", style: "background-color: white",
    insertValue: function() {
        this.$.webView.insertStringAtCursor(this.$.autoInsertTool.getValue());
        this.$.autoInsertTool.setValue(this.$.autoInsertTool.getPassword());
    },
    rendered: function() {
        this.$.autoInsertTool.open();
    },
    components: [{
        kind: "AutoInsertTool",
        disabled: true,
        username: "my username",
        password: "some password",
        style: "width: 300px; position: absolute; bottom: 5px; right: 5px;"
    },{
        kind: "WebView", url: "http://www.google.com", onEditorFocusChanged: "insertValue", flex: 1
    }]
});
