enyo.kind({
    name: "maklesoft.browser.BookmarkDialog",
    kind: "BookmarkDialog",
    style: "width: 500px; padding: 0px 10px 10px 10px;",
    published: {
        hasLogin: false,
        credentials: null
    },
    rendered: function() {
        this.inherited(arguments);
        this.hasLoginChanged();
    },
    hasLoginChanged: function() {
		if (!this.lazy) {
			this.$.hasLoginCheckBox.setChecked(this.hasLogin);
            this.toggleCredentialsDrawer();
		}
    },
    credentialsChanged: function() {
        if (!this.lazy) {
            if (this.credentials) {
                this.$.loginNameInput.setValue(this.credentials.loginName);
                this.$.passwordInput.setValue(this.credentials.password);
            } else {
                this.$.loginNameInput.setValue("");
                this.$.passwordInput.setValue("");
            }
        }
    },
    toggleCredentialsDrawer: function() {
        this.$.credentialsDrawer.setOpen(this.$.hasLoginCheckBox.getChecked());
    },
	acceptClick: function() {
		this.doAccept(this.getTitle(), this.getUrl(), this.icons, this.getId(), this.getHasLogin(), this.getCredentials());
		this.close();
	},
	getHasLogin: function() {
	    return this.$.hasLoginCheckBox.getChecked();
	},
	getCredentials: function() {
	    if (!this.getHasLogin()) {
	        return null;
	    } else {
	        return {loginName: this.$.loginNameInput.getValue(), password: this.$.passwordInput.getValue()};
	    }
	},
	iconsChanged: function() {
	},
	components: [
		{kind: "HFlexBox", components: [
		    {name: "titleInput", kind: "Input", flex: 1, insetClass: "enyo-flat-shadow", onkeydown: "inputKeydown", selectAllOnFocus: true, components: [{className: "enyo-label", content: $L("title")}]}
		]},
		{name: "urlInput", kind: "Input", inputType: "url", insetClass: "enyo-flat-shadow", selectAllOnFocus: true, components: [{className: "enyo-label", content: $L("url")}]},
		{kind: "HFlexBox", style: "padding: 5px", align: "center", components: [
		    {name: "hasLoginCheckBox", kind: "CheckBox", style: "margin-right: 15px", onChange: "toggleCredentialsDrawer"},
		    {kind: "Spacer"},
		    {className: "enyo-label", content: $L("has login"), style: "padding: 5px"}
		]},
		{name: "credentialsDrawer", kind: "Drawer", components: [
		    {name: "loginNameInput", kind: "Input", components: [{className: "enyo-label", content: $L("login name")}]},
		    {name: "passwordInput", kind: "PasswordInput", components: [{className: "enyo-label", content: $L("password")}]}
		]},
		{kind: enyo.HFlexBox, components: [
			{kind: "NoFocusButton", flex: 1, caption: $L("Cancel"), onclick: "cancelClick"},
			{name: "acceptButton", className: "enyo-button-dark", flex: 1, kind: "NoFocusButton", onclick: "acceptClick"}
		]}
	],
});