enyo.kind({
    name: "BookmarkGridItem",
    kind: "VFlexBox",
    style: "padding: 20px",
    events: {
        onDelete: ""
    },
    published: {
        thumbnail: "",
        title: "",
        hasLogin: false,
        deleteable: true
    },
    mousedownHandler: function() {
        this.addClass("down");
    },
    mouseupHandler: function() {
        this.removeClass("down");
    },
    mouseoutHandler: function() {
        this.removeClass("down");
    },
    create: function() {
        this.inherited(arguments);
        this.thumbnailChanged();
        this.titleChanged();
    },
    thumbnailChanged: function() {
        this.$.thumbnail.setSrc(this.thumbnail);
    },
    titleChanged: function() {
        this.$.title.setContent(this.title);
    },
    deleteableChanged: function() {
        this.$.deleteButton.applyStyle("visibility", this.deleteable ? "visible" : "hidden");
    },
//    hasLoginChanged: function() {
//        //enyo.log("has login changed: " + this.hasLogin);
//        this.$.lockIcon.setShowing(this.hasLogin);
//    },
    deleteBookmark: function(sender, event) {
        this.doDelete(event);
        return true;
    },
    components: [
        {kind: "HFlexBox", className: "bookmark-grid-actionbar", components: [
		    {name: "deleteButton", kind: "CustomButton", className: "bookmark-grid-button stop-button", onclick: "deleteBookmark"}
		    //{name: "editButton", kind: "CustomButton", className: "bookmark-grid-button edit-button", onclick: "deleteBookmark"}
		]},
        {className: "thumbnail-container", layoutKind: "VFlexLayout", align: "center", pack: "center", components: [
            {name: "thumbnail", className: "thumbnail", kind: "Image"}
            //{name: "thumbOverlay", className: "thumbnail-overlay"}
        ]},
        {kind: "HFlexBox", pack: "center", align: "center", components: [
            {name: "title", className: "bookmark-title ellipsis"},
            {name: "lockIcon", showing: false, kind: "Image", src: "images/chrome/secure-lock.png"}
        ]}
    ]
});