enyo.kind({
    name: "maklesoft.browser.Browser",
    kind: "Browser",
    events: {
        onNewTab: "",
        onOpenStartPage: "",
        onShowTabs: "",
        onHideTabs: ""
    },
    create: function() {
        this.inherited(arguments);
        this.createComponent({
            kind: "AutoInsertTool", flyInFrom: "bottom",
            style: "width: 300px; position: absolute; bottom: 5px; right: 5px;"
        });
        this.createComponent({
            kind: "LoginSelect", style: "position: absolute; right: 5px; bottom: 5px; width: 250px", onLoginSelected: "loginSelected", flyInFrom: "bottom"
        });
		this.createComponent({name: "bookmarksService", kind: "DbService", method: "search", dbKind: enyo.fetchAppInfo().id + ".browserbookmarks:1", onSuccess: "gotMatchingBookmarks"});
        this.$.view.onEditorFocusChanged = "focusedHandler";
        this.$.actionbar.onSearch = "search";
        this.$.actionbar.onNewTab = "newTabHandler";
        this.$.actionbar.onOpenStartPage = "doOpenStartPage";
        this.$.actionbar.onAddToInstaPaper = "addToInstaPaper";
        this.$.actionbar.onShowTabs = "doShowTabs";
        this.$.actionbar.onHideTabs = "doHideTabs";
        this.$.actionbar.onTweetUrl = "tweetCurrentUrl";
        this.createComponent({name: "launchApp", kind: "PalmService", service: "palm://com.palm.applicationManager/", method: "launch"})
        this.createComponent({kind: "AppMissing"});
    },
    openAutoInsertTool: function(username, password, title) {
        this.$.autoInsertTool.setUsername(username);
        this.$.autoInsertTool.setPassword(password);
        this.$.autoInsertTool.setTitle(title);
        this.$.autoInsertTool.setValue(username);
        this.$.autoInsertTool.open();
    },
    closeAutoInsertTool: function() {
        this.$.autoInsertTool.close();
    },
    focusedHandler: function() {
        if (!this.$.autoInsertTool.getDisabled()) {
            this.$.view.insertStringAtCursor(this.$.autoInsertTool.getValue());
            this.$.autoInsertTool.setValue(this.$.autoInsertTool.getPassword());
        }
    },
    pageTitleChanged: function(inSender, inTitle, inUrl, inBack, inForward) {
        this.inherited(arguments, [inSender, inTitle, inUrl, inBack, inForward]);
        //enyo.log("TITLECHANGED: url: " + inUrl);
        var regex = /(https?:\/\/[^\/]+\.[^\/]+)+(\/.*)?/;
        var match = inUrl.match(regex);
        if (match) {
            var domain = match[1];
            //enyo.log("**************** domain: " + domain);
            var query = {
                where: [{prop: "url", op: "%", val: domain}]
            };
            this.$.bookmarksService.call({query: query}, {onFailure: "dbFailure"});
        }
    },
    gotMatchingBookmarks: function(sender, response) {
        //enyo.log("*************** got matching bookmarks: " + JSON.stringify(response.results));
        var logins = []
        for (var i = 0; i < response.results.length; i++) {
            if (response.results[i].hasLogin) {
                logins.push(response.results[i]);
            }
        }
        if (logins.length) {
            this.$.loginSelect.setLogins(logins);
            this.$.loginSelect.open();
        } else {
            this.$.loginSelect.close();
        }
    },
    dbFailure: function(sender, response) {
        enyo.error("Database error! " + response.errorText + " (Code: " + response.errorCode + ")");
    },
    search: function(sender, event) {
        this.$.view.findInPage("");
        for (var i=0; i<=event.index; i++) {
            this.$.view.findInPage(event.text);
        }
    },
    newTabHandler: function() {
        this.doNewTab();
    },
    loginSelected: function(sender, login) {
        this.$.loginSelect.close();
        this.openAutoInsertTool(login.credentials.loginName, login.credentials.password, login.title);
    },
    addToInstaPaper: function() {
        this.$.launchApp.call({id: "net.ryanwatkins.app.papermache", params: {action: "add", url: this.url, title: this.title}}, {onFailure: "launchAppFailure"});
    },
    tweetCurrentUrl: function() {
        this.tweetUrl(this.url);
    },
    tweetUrl: function(url) {
        this.$.launchApp.call({id: "com.funkatron.app.spaz-hd", params: {tweet: url}}, {onFailure: "launchAppFailure"});
    },
    launchAppFailure: function(sender, e) {
        //enyo.log("******* launching app failed! " + JSON.stringify(e));
        if (e.errorText=='"net.ryanwatkins.app.papermache" was not found') {
            this.$.appMissing.setAppTitle("Paper Mache");
            this.$.appMissing.setAppId("net.ryanwatkins.app.papermache");
            this.$.appMissing.openAtCenter();
        } else if (e.errorText=='"com.funkatron.app.spaz-hd" was not found') {
            this.$.appMissing.setAppTitle("Spaz HD");
            this.$.appMissing.setAppId("com.funkatron.app.spaz-hd");
            this.$.appMissing.openAtCenter();
        }
    },
    setWebViewId: function(id) {
        //enyo.log("*************** setting identifier: " + id);
        this.$.view.setIdentifier(id);
    },
    shareOnTwitter: function(inTapInfo, inPosition) {
        this.tweetUrl(inTapInfo.linkUrl);
    },
    newTabClick: function(inTapInfo, inPosition) {
        this.doNewTab({url: inTapInfo.linkUrl});
    }
//    openNewCardWithIdentifier: function(sender, identifier) {
//        this.doNewTab({identifier: identifier});
//    }
});
