enyo.kind({
	name: "maklesoft.Grid",
	kind: enyo.VFlexBox,
	published: {
	    cellWidth: 200,
	    cellsPerRow: 0
	},
	events: {
	    onSetupCell: "",
	    onItemSelected: ""
	},
	components: [{
	    kind: "Scroller", flex: 1, components: [
		{name: "list", kind: "VirtualRepeater", onSetupRow: "listSetupRow", components: [
			{name: "cells", kind: "HFlexBox"}
		]}]
	}],
	refresh: function() {
	    //this.buildCells();
	    this.$.list.render();
	},
	create: function() {
	    this.items = [];
	    this.cells = [];
	    this.inherited(arguments);
	},
//	rendered: function() {
//	    this.buildCells();
//	},
	resizeHandler: function() {
		var bounds = this.$.list.getBounds();
		var cellCount = this.getCellsPerRow() || Math.floor(bounds.width / this.cellWidth);
		if (cellCount != this.cellCount) {
		    this.buildCells();
		    this.refresh();
		}
	},
	cellWidthChanged: function() {
	    this.buildCells();
	    this.render();
	},
	cellsPerRowChanged: function() {
        this.buildCells();
	    this.render();
	},
	buildCells: function() {
		var bounds = this.$.list.getBounds();
		this.cellCount = this.getCellsPerRow() || Math.floor(bounds.width / this.cellWidth);
		this.$.cells.destroyControls();
		this.cells = [];
		this.items = [];
		for (var i=0; i<this.cellCount; i++) {
			var c = this.$.cells.createComponent({
			    flex: 1, kind: "VFlexBox", pack: "center", align: "center", idx: i, owner: this, style: "width: " + this.cellWidth + "px", onmousedown: "setIndex"}
			);
			
			var item = c.createComponent(this.item, {owner: this.owner});
			this.cells.push(c);
			this.items.push(item);
		}
	},
	listSetupRow: function(inSender, inIndex) {
		var idx = inIndex * this.cellCount;
		var hasCell = false;
		for (var i=0, c, item; c=this.cells[i], item=this.items[i]; i++, idx++) {
			if (this.doSetupCell(item, idx)) {
			    item.show();
			    hasCell = true;
			} else {
			    item.hide();
			}
		}
		return hasCell;
	},
	captureDomEvent: function(e) {
		if (e.type != "mousemove") {
		    e.cellIndex = this.currentIndex;
		}
	},
	setIndex: function(inSender, inEvent) {
		var index = inEvent.rowIndex * this.cellCount + inSender.idx;
	    this.currentIndex = index;
	}
});