enyo.kind({
    name: "LoginSelect",
    kind: "Toaster",
    className: "login-select",
    lazy: false,
    dismissWithClick: false,
    published: {
        logins: []
    },
    events: {
        onLoginSelected: ""
    },
    create: function() {
        this.inherited(arguments);
        this.loginsChanged();
    },
    loginsChanged: function() {
        this.$.list.render();
    },
    listSetupRow: function(sender, index) {
        var login = this.logins[index];
        if (login) {
            this.$.item.setContent(login.title);
            if (index == 0) {
                this.$.item.addClass("enyo-first");
            } else {
                this.$.item.removeClass("enyo-first");
            }
            return true;
        }
    },
    toggleDrawer: function() {
        this.$.listDrawer.setOpen(!this.$.listDrawer.getOpen());
    },
    loginClick: function(sender, event) {
        this.doLoginSelected(this.logins[event.rowIndex]);
        this.$.toggleButton.setDepressed(false);
        this.$.listDrawer.setOpen(false);
    },
    close: function() {
        this.inherited(arguments);
        this.$.toggleButton.setDepressed(false);
        this.$.listDrawer.setOpen(false);
    },
    components: [
        {name: "listDrawer", kind: "BasicDrawer", open: false, style: "height: 100px", components: [
            {name: "list", kind: "VirtualRepeater", onSetupRow: "listSetupRow", components: [
                {name: "item", kind: "Item", className: "ellipsis", tapHighlight: true, onclick: "loginClick"}
            ]}
        ]},
        {kind: "HFlexBox", align: "center", components: [
            {name: "toggleButton", kind: "Button", flex: 1, className: "enyo-button-dark", caption: "Logins available!", toggling: true, onclick: "toggleDrawer"},
            //{kind: "ToolButton", style: "padding: 0px; margin: 0px -20px 0px 0px;", icon: "images/delete_button_32.png", onclick: "close"}
		    {kind: "CustomButton", className: "bookmark-grid-button stop-button", onclick: "close"}
        ]}
    ]
});

enyo.kind({
    name: "LoginSelectTest",
    kind: "VFlexBox",
    openLoginSelect: function() {
        this.$.loginSelect.open();
    },
    closeLoginSelect: function() {
        this.$.loginSelect.close();
    },
    components: [
        {kind: "Button", onclick: "openLoginSelect"},
        {kind: "Button", onclick: "closeLoginSelect"},
        {kind: "LoginSelect", style: "position: absolute; right: 5px; bottom: 5px; width: 200px", flyInFrom: "bottom", logins: [
            {title: "one login"},
            {title: "another one"}
        ]}
    ]
});