enyo.kind({
    name: "maklesoft.browser.StartPage",
    kind: "StartPage",
    events: {
        onDeleteBookmark: "",
        onNewBookmark: ""
    },
    create: function() {
        this.inherited(arguments);
        this.$.tall.destroy();
        this.createComponent({
            name: "bookmarks",
            kind: "maklesoft.Grid",
            onSetupCell: "setupBookmark",
            item: {kind: "BookmarkGridItem", onclick:"bookmarkClick", onDelete: "deleteBookmark"},
            cellWidth: 300, flex: 1
        });
        this.createComponent({
            name: "bookmarksService", kind: "DbService", dbKind: enyo.fetchAppInfo().id + ".browserbookmarks:1", reCallWatches: true, method: "find",
            onSuccess: "gotBookmarks", subscribe: true, onWatch:"refreshBookmarks"
        });
        this.refreshBookmarks();
    },
    bookmarkClick: function(sender, event) {
        var bookmark = this.bookmarks[event.cellIndex];
        if (bookmark) {
		    this.doUrlChange(bookmark.url);
		} else {
		    this.doNewBookmark();
		}
    },
    deleteBookmark: function(sender, event) {
        var bookmark = this.bookmarks[event.cellIndex];
        this.doDeleteBookmark(bookmark);
    },
    refreshBookmarks: function() {
        this.$.bookmarksService.call();
    },
    gotBookmarks: function(sender, response) {
        //enyo.log("got bookmarks: " + JSON.stringify(response));
        this.bookmarks = response.results;
        this.$.bookmarks.refresh();
    },
    setupBookmark: function(sender, item, index) {
        //enyo.log(" ************** setting up bookmark " + index);
        if (this.bookmarks) {
            var bookmark = this.bookmarks[index];
        }
        if (bookmark) {
            item.setDeleteable(true);
            item.setTitle(bookmark.title);
            item.setThumbnail(websnapr_snapshot(bookmark.url));
            item.setHasLogin(bookmark.hasLogin);
            return true;
        } else if (index == this.bookmarks.length) {
            item.setDeleteable(false);
            item.setTitle("New Bookmark");
            item.setThumbnail("images/new_bookmark.png");
            item.setHasLogin(false);
            return true;
        }
    },
    showingChanged: function() {}
});